/*
 * This library contains code used to send positioning requests (normal,
 * calibration or autocalibration) to the aggregaton server.
 */

#ifndef _LIBOWLPS_CLIENT_
#define _LIBOWLPS_CLIENT_

#include <owlps.h>

/* Error codes */
#define ERR_CREATING_SOCKET 151 // Error when creating output socket
#define ERR_SENDING_INFO 152 // Error sending a localisation request


/* Function headers */
int owlclient_create_trx_socket(char *dest_ip, uint_fast16_t dest_port,
                                struct sockaddr_in *server,
                                char *iface) ;
void owlclient_use_iface(int sockfd, char *iface) ;
void owlclient_send_request(int sockfd, struct sockaddr_in *server,
                            void *packet, uint_fast16_t packet_size,
                            uint_fast16_t nb_pkt, uint_fast32_t delay) ;
void owlclient_send_packet(int sockfd, struct sockaddr_in *server,
                           void *packet, uint_fast16_t packet_size) ;


#endif // _LIBOWLPS_CLIENT_
