#include "realposition.hh"
#include "calibrationrequest.hh"
#include "referencepoint.hh"



Result RealPosition::compute(const Request &request)
{
  const CalibrationRequest *calibration_request =
    dynamic_cast<const CalibrationRequest*>(&request) ;

  if (calibration_request != NULL)
    {
      Point3D *coordinates =
        static_cast<Point3D*>(
          calibration_request->get_reference_point()) ;
      return Result(&request, *coordinates) ;
    }

  return Result(&request) ;
}
